/***************************************************************
 *
 * include/input.h
 * Header for input libraries
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#ifndef ____INPUT_H_
#define ____INPUT_H_
// kbdinit.c
void KbdInit(void);
int KbdReadKey(void);
void KbdPushKey(int);

int i8042_scan2key(int c);
void i8042_kbd_irq(void *r);
char i8042_command(int command, int argc);
BOOL i8042_kbd_detect(void);
void i8042_kbd_init(void);

extern uint32_t kbd_flags;
extern uint32_t kbd_cons_flags;

#define KEY_ESC 	0xFF000001
#define KEY_HOME	0xFF000002
#define KEY_END 	0xFF000003
#define KEY_PGUP	0xFF000004
#define KEY_PGDN	0xFF000005
#define KEY_UP  	0xFF000006
#define KEY_DN  	0xFF000007
#define KEY_LFT 	0xFF000008
#define KEY_RT  	0xFF000009
#define KEY_INS 	0xFF00000A
#define KEY_DEL 	0xFF00000B

#define KBF_SHIFT	0x00000001
#define KBF_CTRL	0x00000002
#define KBF_ALT 	0x00000004
#define KBF_LSHIFT	0x00000008
#define KBF_LCTRL	0x00000010
#define KBF_LALT	0x00000020
#define KBF_RSHIFT	0x00000040
#define KBF_RCTRL	0x00000080
#define KBF_RALT	0x00000100
#define KBF_CAPSLK	0x00000200
#define KBF_NUMLK	0x00000400
#define KBF_SCRLK	0x00000800
#define KBF_INSERT	0x00001000
#define KBF_CAPSHD	0x00002000
#define KBF_NUMHD	0x00004000
#define KBF_SCRHD	0x00008000

#endif
