/****************************************************************

kernel/include/kernel.h
Core kernel declarations for AWOS

See the LICENSE file included with this source for copyright
information.

****************************************************************/

#ifndef ____KERNEL_H_
#define ____KERNEL_H_
#include <sys/types.h>
#include <stdio.h>

typedef struct multiboot_info
{
	unsigned long flags;
	unsigned long mem_lower;
	unsigned long mem_upper;
	unsigned long boot_device;
	unsigned long cmdline;
	unsigned long mods_count;
	unsigned long mods_addr;
} multiboot_info_t;

int printf(const char *, ...);
void dprintf(const char *, ...);

void putchar(const unsigned char);

void __attribute__((noreturn)) panic(const char *);

extern char irq_for_grabs[16]; // A way of getting IRQ notices to stuff which doesn't install a handler :\ -GM
void KiIrqInstall(int, void(*handler)(void *), char *);
void KiIrqUninstall(int);

void csleep(uint32_t);
void yield(void);
void exit(int code);

void __assert_fail(const char *cond, const char *file, int line, const char *func);

char *k_cmdline_check(char *, char *);
char *k_kcmdline_check(char *);

void __cxa_pure_virtual (void);

#ifndef TRUE
	typedef char BOOL;
	#define TRUE 0
	#define FALSE 1
#endif

extern BOOL debug;

#endif

