/***************************************************************
 *
 * include/macros.h
 * Macros for AWOS kernel
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#ifndef ____MACROS_H_
#define ____MACROS_H_

void __attribute__((noreturn)) __assert_fail(const char *cond, const char *file, int line, const char *func);
void	__fixme	(const char *fnname);
void	__fixmed(const char *fnname, const char *file, int line);

#ifdef DEBUG
	#define assert(cond) do { if(!(cond)) __assert_fail(#cond, __FILE__, __LINE__, __func__); } while(0)
	#define fixme() __fixmed(__func__, __FILE__, __LINE__)
#else
	#define assert(cond) /* nothing */
	#define fixme() __fixme(__func__);
#endif	/* DEBUG */

#endif /* !___MACROS_H_ */

