/****************************************************************
 *
 * cons/consinit.c
 * Console initialisation routines for AWOS
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ****************************************************************/

#include <cons.h>

console_t ttys[NUM_TTYS];
char cons_space[0xFA0 * NUM_TTYS]; // -GM
console_t *currtty;
struct cons_class *cons_currclass;

extern void VgaCtlInit(void);
void ConInit()
{
	int i;
	int mem = (int)&cons_space[0];

	for(i = 0; i < NUM_TTYS; i++)
	{
		ttys[i].mem = (unsigned char *)mem;
		ttys[i].ttymem = (unsigned char *)mem;
		ttys[i].vrammem = (unsigned char *)0xB8000;
		ttys[i].currmem = (unsigned char *)mem;
		ttys[i].tx = 0;
		ttys[i].ty = 0;
		ttys[i].tw = 80;
		ttys[i].th = 25;
		ttys[i].fw = 2; // 2 bytes
		ttys[i].fh = 1; // 1 line
		
		ttys[i].color = 0x07;
		ttys[i].memlen = 0xFA0;
		ttys[i].tline = 0xA0;
		ttys[i].gline = 0xA0;
		ttys[i].flags = 0;
		ttys[i].tablen = 8;
		
		cons_currclass = ttys[i].driver = &cons_vga_80x25;
		
		/* 2000 chars * 2 bytes per char = 0xFA0 bytes */
		mem += 0xFA0;
	};
	
	currtty = &ttys[0];
	currtty->driver->pop(currtty);
	VgaCtlInit();
	VgaClearScreen();
};

