###############################################################
#
# cons/vesa_v86.asm
# VESA VBE driver (16-bit part)
#
# See LICENSE file include with this source for copyright
# information.
# 
###############################################################

.intel_syntax noprefix

.code16

.global vesa_v86_getinfo
.global vesa_v86_getinfo_end
.global vesa_v86_gen
.global vesa_v86_gen_end
.global vesa_v86_setmode
.global vesa_v86_setmode_end
.global vesa_v86_getmodeinfo
.global vesa_v86_getmodeinfo_end

.text

.balign 16
vesa_v86_getinfo:
	mov ax,0x4F00
	mov di,0xC002
	int 0x10
	dec di
	dec di
	stosw
	iret
.balign 16
vesa_v86_getinfo_end:

vesa_v86_getmodeinfo:
	mov ax,0x4F01
	mov cx,word ptr 0xC002
	mov di,0xC004
	int 0x10
	sub di,0x04
	stosw
	iret
.balign 16
vesa_v86_getmodeinfo_end:

vesa_v86_setmode:
	mov ax,0x4F02
	mov bx,word ptr 0xC002
	mov di,0xC004
	int 0x10
	sub di,0x04
	stosw
	iret
.balign 16
vesa_v86_setmode_end:

vesa_v86_gen:
	mov bx, word ptr 0xC002
	mov cx, word ptr 0xC004
	mov dx, word ptr 0xC006
	mov si, word ptr 0xC008
	mov di, word ptr 0xC00A
	mov bp, word ptr 0xC00C
	mov ax, word ptr 0xC00E
	mov es,ax
	mov ax, word ptr 0xC000
	int 0x10
	push ds
	mov word ptr ds:0xc000, ax
	mov word ptr ds:0xc002, bx
	mov word ptr ds:0xc004, cx
	mov word ptr ds:0xC006, dx
	mov word ptr ds:0xC008, si
	mov word ptr ds:0xC00A, di
	mov word ptr ds:0xC00C, bp
	mov ax,es
	mov word ptr ds:0xC00E, ax
	pop ds
	iret
.balign 16
vesa_v86_gen_end:

