/****************************************************************
 * 
 * arch/i386/mp.c
 * x86 multiprocessor support (based on Intel MP 1.4 standard)
 * 
 * See LICENSE file included with this source for copyright
 * information.
 * 
 ****************************************************************/

#include <kernel.h>
#include <mp.h>
#include <string.h>

extern void *kcalloc(size_t);
extern void kfree(void *);

struct MpFloating *floating;

int MpInitialise(void)
{
	char *BIOSmem = (char *)0xF0000;

	floating = kcalloc(sizeof(struct MpFloating));

	for(; (int)BIOSmem < 0xFFFFF; BIOSmem += 0x10)
	{
		if(!strncmp("_MP_", BIOSmem, 4))
		{
			memcpy(floating, BIOSmem, sizeof(struct MpFloating));

			if(floating->feature[0] == 0)
				return 2;
			else
				return (int)floating->config->entry_count;
		};
	};
	
	/* no MP structure */
	kfree(floating);
	return 1;
};

