/***************************************************************
 *
 *  syscall.c
 *  system calls for AWOS
 *
 *  See LICENSE file included with this source for copyright
 *  information
 *
 ***************************************************************/

#include "syscall.h"
#include <cpuspec.h>

/** The syscall table.  Should be more exciting than this, but meh. **/
syscall_fn Syscalls[2];

extern void exit(int);
extern void putchar(const unsigned char);

void __attribute__((fastcall)) _KiDispatchSyscall(uint32_t syscall, void *retloc, uint32_t *userStack)
{
	long *result = (long *)retloc;
	*result = (long)_KiRealDispatchSyscall(Syscalls[syscall], userStack);
};

/* piece of fail atm. */
void _KiTranslateIsrSyscall(struct regs *r)
{
	(void)r;
	return;
};

void KsSyscallTable(void)
{
	Syscalls[0] = (uint32_t)&exit;
	Syscalls[1] = (uint32_t)&putchar;
};
