/******************************************************************
 *
 * x86_isrs.S
 * Interrupt services for AWOS x86
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ******************************************************************/

.intel_syntax noprefix

.globl idt_update
.extern idt_ptr
idt_update:
	lidt [idt_ptr]
	ret

####ISRs####
.globl isr00
.globl isr01
.globl isr02
.globl isr03
.globl isr04
.globl isr05
.globl isr06
.globl isr07
.globl isr08
.globl isr09
.globl isr0A
.globl isr0B
.globl isr0C
.globl isr0D
.globl isr0E
.globl isr0F
.globl isr10
.globl isr11
.globl isr12
.globl isr13
.globl isr14
.globl isr15
.globl isr16
.globl isr17
.globl isr18
.globl isr19
.globl isr1A
.globl isr1B
.globl isr1C
.globl isr1D
.globl isr1E
.globl isr1F
.globl isr20
.globl isr21
.globl isr22
.globl isr23
.globl isr24
.globl isr25
.globl isr26
.globl isr27
.globl isr28
.globl isr29
.globl isr2A
.globl isr2B
.globl isr2C
.globl isr2D
.globl isr2E
.globl isr2F
.globl isr30
.globl isr31
.globl isr32
.globl isr33
.globl isr34
.globl isr35
.globl isr36
.globl isr37
.globl isr38
.globl isr39
.globl isr3A
.globl isr3B
.globl isr3C
.globl isr3D
.globl isr3E
.globl isr3F

isr00:
	cli
	push 0
	push 0
	jmp isr_common

isr01:
	cli
	push 0
	push 1
	jmp isr_common

isr02:
	cli
	push 0
	push 2
	jmp isr_common

isr03:
	cli
	push 0
	push 3
	jmp isr_common

isr04:
	cli
	push 0
	push 4
	jmp isr_common

isr05:
	cli
	push 0
	push 5
	jmp isr_common

isr06:
	cli
	push 0
	push 6
	jmp isr_common

isr07:
	cli
	push 0
	push 7
	jmp isr_common

isr08:
	cli
	mov ax,0x0010
	mov ds,ax
	mov ebx,0xB8000
	mov ax,0xCE21
	mov [ebx],eax
	hlt

isr09:
	cli
	push 0
	push 9
	jmp isr_common

isr0A:
	cli
	push 10
	jmp isr_common

isr0B:
	cli
	push 11
	jmp isr_common

isr0C:
	cli
	push 12
	jmp isr_common

isr0D:
	cli
	push 13
	jmp isr_common

isr0E:
	cli
	push 14
	jmp isr_common

isr0F:
	cli
	push 0
	push 15
	jmp isr_common

isr10:
	cli
	push 0
	push 16
	jmp isr_common

isr11:
	cli
	push 0
	push 17
	jmp isr_common

isr12:
	cli
	push 0
	push 18
	jmp isr_common

isr13:
	cli
	push 0
	push 19
	jmp isr_common

isr14:
	cli
	push 0
	push 20
	jmp isr_common

isr15:
	cli
	push 0
	push 21
	jmp isr_common

isr16:
	cli
	push 0
	push 22
	jmp isr_common

isr17:
	cli
	push 0
	push 23
	jmp isr_common

isr18:
	cli
	push 0
	push 24
	jmp isr_common

isr19:
	cli
	push 0
	push 25
	jmp isr_common

isr1A:
	cli
	push 0
	push 26
	jmp isr_common

isr1B:
	cli
	push 0
	push 27
	jmp isr_common

isr1C:
	cli
	push 0
	push 28
	jmp isr_common

isr1D:
	cli
	push 0
	push 29
	jmp isr_common

isr1E:
	cli
	push 0
	push 30
	jmp isr_common

isr1F:
	cli
	push 0
	push 31
	jmp isr_common
	
isr20:
	cli
	push 0
	push 32
	jmp isr_common
	
isr21:
	cli
	push 0
	push 33
	jmp isr_common
	
isr22:
	cli
	push 0
	push 34
	jmp isr_common
	
isr23:
	cli
	push 0
	push 35
	jmp isr_common
	
isr24:
	cli
	push 0
	push 36
	jmp isr_common

isr25:
	cli
	push 0
	push 37
	jmp isr_common

isr26:
	cli
	push 0
	push 38
	jmp isr_common
	
isr27:
	cli
	push 0
	push 39
	jmp isr_common
	
isr28:
	cli
	push 0
	push 40
	jmp isr_common

isr29:
	cli
	push 0
	push 41
	jmp isr_common

isr2A:
	cli
	push 0
	push 42
	jmp isr_common
	
isr2B:
	cli
	push 0
	push 43
	jmp isr_common
	
isr2C:
	cli
	push 0
	push 44
	jmp isr_common
	
isr2D:
	cli
	push 0
	push 45
	jmp isr_common
	
isr2E:
	cli
	push 0
	push 46
	jmp isr_common
	
isr2F:
	cli
	push 0
	push 47
	jmp isr_common

isr30:
	cli
	push 0
	push 48
	jmp isr_common
	
isr31:
	cli
	push 0
	push 49
	jmp isr_common
	
isr32:
	cli
	push 0
	push 50
	jmp isr_common
	
isr33:
	cli
	push 0
	push 51
	jmp isr_common

isr34:
	cli
	push 0
	push 52
	jmp isr_common
	
isr35:
	cli
	push 0
	push 53
	jmp isr_common
	
isr36:
	cli
	push 0
	push 54
	jmp isr_common
	
isr37:
	cli
	push 0
	push 55
	jmp isr_common

isr38:
	cli
	push 0
	push 56
	jmp isr_common
	
isr39:
	cli
	push 0
	push 57
	jmp isr_common
	
isr3A:
	cli
	push 0
	push 58
	jmp isr_common
	
isr3B:
	cli
	push 0
	push 59
	jmp isr_common

isr3C:
	cli
	push 0
	push 60
	jmp isr_common
	
isr3D:
	cli
	push 0
	push 61
	jmp isr_common
	
isr3E:
	cli
	push 0
	push 62
	jmp isr_common
	
isr3F:
	cli
	push 0
	push 63

.extern KiFaultHandler

isr_common:
	pusha
	push ds
	push es
	push fs
	push gs
	mov ax,0x10
	mov ds,ax
	mov es,ax
	mov fs,ax
	mov gs,ax
	mov eax,esp
	push eax
	call KiFaultHandler
	mov esp,eax
	pop gs
	pop fs
	pop es
	pop ds
	popa
	add esp,8
	iret

.globl irq00
.globl irq01
.globl irq02
.globl irq03
.globl irq04
.globl irq05
.globl irq06
.globl irq07
.globl irq08
.globl irq09
.globl irq0A
.globl irq0B
.globl irq0C
.globl irq0D
.globl irq0E
.globl irq0F

.extern __KiGetNextTask
irq00:
	cli
	sub esp,8
	pusha
	push gs
	push fs
	push es
	push ds
	mov eax,esp
	push eax
	call __KiGetNextTask
	mov esp,eax
	
	lea eax,[esp + 72]	# get the address of the stack
	push ecx			# save ECX
	str ecx				# put the TSS address in ECX
	mov [ecx + 4],eax	# put the stack addy in the TSS
	pop ecx				# restore ECX
	
	pop ds
	pop es
	pop fs
	pop gs
	mov dx,0x20
	mov al,0x20
	out dx,al
	popa
	add esp,8
	sti
	iret

irq01:
	cli
	push 0x0
	push 0x1
	jmp irq_common

irq02:
	cli
	push 0x0
	push 0x2
	jmp irq_common

irq03:
	cli
	push 0x0
	push 0x3
	jmp irq_common

irq04:
	cli
	push 0x0
	push 0x4
	jmp irq_common

irq05:
	cli
	push 0x0
	push 0x5
	jmp irq_common

irq06:
	cli
	push 0x0
	push 0x6
	jmp irq_common

irq07:
	cli
	push 0x0
	push 0x7
	jmp irq_common

irq08:
	cli
	push 0x0
	push 0x8
	jmp irq_common

irq09:
	cli
	push 0x0
	push 0x9
	jmp irq_common

irq0A:
	cli
	push 0x0
	push 0x0A
	jmp irq_common

irq0B:
	cli
	push 0x0
	push 0x0B
	jmp irq_common

irq0C:
	cli
	push 0x0
	push 0x0C
	jmp irq_common

irq0D:
	cli
	push 0x0
	push 0x0D
	jmp irq_common

irq0E:
	cli
	push 0x0
	push 0x0E
	jmp irq_common

irq0F:
	cli
	push 0x0
	push 0x0F
	jmp irq_common

.extern KiIrqHandler

irq_common:
	pusha
	push ds
	push es
	push fs
	push gs
	mov ax,0x10
	mov ds,ax
	mov es,ax
	mov fs,ax
	mov gs,ax
	mov eax,esp
	push eax
	call KiIrqHandler
	pop eax
	pop gs
	pop fs
	pop es
	pop ds
	popa
	add esp,8
	iret

.globl isr_null
isr_null:
	iret
