/****************************************************************

driver/fs/fs.c
Filesystem core code

See LICENSE file included with this source for copyright
information.

****************************************************************/

#include <kernel.h>
#include <cons.h>
#include <input.h>
#include <kalloc.h>
#include <sys/types.h>
#include <string.h>
#include <fs.h>
#include <stdlib.h>

struct fs_def_ll *defll;
void *fs_root_data = NULL;
struct fs_def *fs_root_def = NULL;

// FsAddFileSystem adds a file system from a driver.
void FsAddFileSystem(uint32_t magic, struct fs_def *def){
	struct fs_def_ll *d;
	d = defll;
	if(d == NULL){
		d = defll = malloc(sizeof(struct fs_def_ll));
	} else {
		while(d->n != NULL)
		{
			d = d->n;
		};
		
		d->n = malloc(sizeof(struct fs_def_ll));
		d = d->n;
	};
	d->magic = magic;
	d->def = def;
	d->n = NULL;
	dprintf("fs: Filesystem %08X registered\n", magic);
};

void FsInit(void)
{
	ramfs_init();
	
	fs_root_def = &ramfs_def;
};
