/****************************************************************
 *
 * drivers/pci/440bx.c
 * Intel 82443BX-compatible PCI Bridge driver
 * 
 * See LICENSE file included with this source for copyright
 * information.
 * 
 ****************************************************************/

#include <kernel.h>
#include <stdint.h>
#include <pci.h>
#include <440bx.h>

void Init440(void)
{
	struct pcidev_ll *device;
	uint32_t nbxcfg;
	
	//device = PciFindByClassB(NULL, 6, 0);
	device = PciFindByProduct(NULL, 0x8086, 0x7190);
	if(device == NULL)
		return;
	
	//if(!(((device->dev).vendor_id == 0x8086) && ((device->dev).device_id == 0x7190)))
	//	return;
	
	nbxcfg = PciReadConf32(0x03FC, device->b, device->s, device->f, 0x50);

	printf("Front side bus speed: %s\n", (nbxcfg && 0x1000) ? "100MHz" : "66MHz");
	
	return;
}
