/***************************************************************
 *
 * fault/panic.c
 * help, I need somebody... for AWOS
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#include <kernel.h>

void panic(const char *message)
{
	printf("Kernel panic: %s\n", message);
	dprintf("*** PANIC '%s'\n", message);
#ifdef NONFATAL_PANIC	/* Should *ONLY* be used for debugging purposes */
	printf("Continuing anyway as specified by NONFATAL_PANIC.\n");
	printf("If anything breaks from this point forward, you get to keep the pieces.\n");
	dprintf("Continuing anyway as specified by NONFATAL_PANIC.\n");
	dprintf("If anything breaks from this point forward, you get to keep the pieces.\n");
#else
	panic_wait();
#endif
}

void panic_wait(void)
{
#ifndef __PPC
        printf("Any key will reboot the system...");
        while(KbdReadKey() == 0) asm("hlt");     /* don't care what key */
        KiRestart();
#else
        while(1) ;
#endif
        /* death */
}
