/***************************************************************
 *
 * libc/assert.h
 * Assertion routines for AWOS libc
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

/* ANSI says assert.h can be included multipule times */
#undef assert
#undef _assert
#undef assertwarn
#undef _assertwarn

#ifdef NDEBUG
#	define assert(e)	((void)0)
#	define _assert(e)	((void)0)
#	define assertwarn(e)	((void)0)
#	define _assertwarn(e)	((void)0)
#else
#	define _assert(e)	assert(e)
#	define assert(e)	((e) ? (void)0 : __assert(__func__, __FILE__, \
				__LINE__, #e))
#	define _assertwarn(e)	assertwarn(e)
#	define assertwarn(e)	((e) ? (void)0 : __assertwarn(__func__, \
				__FILE__, __LINE__, #e))
#endif /* NDEBUG */

/* Declarations */
void __assert(const char *, const char *, int, const char *);
void __assertwarn(const char *, const char *, int, const char *);
