/****************************************************************

cons/putchar.c
AWOS putchar() function

See LICENSE file included with this source for copyright
information.

****************************************************************/

/*! \file putchar.c
 * putchar() function
 */

#include <kernel.h>
#include <cons.h>
#include <string.h>

void putchar(const unsigned char c)
{
	currtty->driver->tseek(currtty, currtty->tx, currtty->ty);

	if(c >= ' ')
	{
		currtty->driver->putch(currtty, c);
		currtty->tx++;
	} else {
		switch(c)
		{
			case '\r':
				currtty->driver->tseek(currtty, 0, currtty->ty++);
				break;
			case '\n':
				currtty->ty++;
				currtty->driver->tseek(currtty, 0, currtty->ty);
				break;
			case '\t':
				currtty->tx += currtty->tablen;
				currtty->tx -= currtty->tx % currtty->tablen;
				currtty->driver->tseek(currtty, currtty->tx, currtty->ty);
			case '\x08':
				if((currtty->flags & CONS_TRANS))
				{
					currtty->flags &= ~CONS_TRANS;
					currtty->driver->tdecx(currtty);
					currtty->driver->putch(currtty, ' ');
					currtty->flags |= CONS_TRANS;
				}
				else
				{
					currtty->driver->tdecx(currtty);
					currtty->driver->putch(currtty, ' ');
				};
			default:
				break;
		};
	};
	
	while(currtty->tx >= currtty->tw){
		currtty->tx -= currtty->tw;
		currtty->ty++;
	}
	while(currtty->ty >= currtty->th){
		currtty->driver->vscroll(currtty);
	}

	return;
};
