/***************************************************************
 *
 * libc/debug/assert.c
 * Assertion routines for AWOS libc
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#include <assert.h>
#include <stdio.h>

/* Terminates the program if the given assertion is false */
void __assert(const char *func, const char *file, int line, const char 
		*failedexpr)
{
	if (func == NULL)
		(void)printf("Your shipment of fail has arrived (Assertion \
		failed): (%s), file %s, line %d.\n", failedexpr, file, line);
	else
		(void)printf("Your shipment of fail has arrived (Assertion \
		failed): (%s), function %s, file %s, line %d.\n", failedexpr,
			func, file, line);
	
	abort();
}

/* Only warns that the assertion failed (not defined by ANSI or posix but a 
 * useful extension nonetheless
 */
void __assertwarn(const char *func, const char *file, int line, const char 
		*failedexpr)
{
	if (func == NULL)
		(void)printf(stderr,
			"Assertion failed (WARNING only): (%s), file %s, line \
			%d.\n", failedexpr, file, line);
	else
		(void)printf(stderr,
			"Assertion failed (WARNING only): (%s), file %s, line \
			%d.\n", failedexpr, func, file, line);
}
